/****************************************************************************
 * $Header: /home/CVS/c/TinyCrack/Source/TinyCrack/crypt.h,v 1.2 2001/12/06 19:53:51 ralph Exp $
 *
 * $Log: crypt.h,v $
 * Revision 1.2  2001/12/06 19:53:51  ralph
 * Commented Header (and fixed a bug with Log keyword)
 *
 *
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/


/*
 * UFC-crypt: ultra fast crypt(3) implementation
 *
 * Copyright (C) 1991, 1992, Free Software Foundation, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Support routine definitions.
 *
 */

#ifndef __CRYPT_LIBRARY_H__
#define __CRYPT_LIBRARY_H__
 
#if __CRYPT_EXPORT__
# define CRYPT_API __declspec (dllexport)
#elif __CRYPT_IMPORT__
# define CRYPT_API __declspec (dllimport)
#else
# define CRYPT_API
#endif

CRYPT_API extern char * crypt (char *key, char *salt);
CRYPT_API extern char * fcrypt (char *key, char *salt);
CRYPT_API extern void encrypt (char *block, int edflag);
CRYPT_API extern void setkey (char *key);
CRYPT_API extern void init_des (void);
/*
CRYPT_API extern char *getpass (char *prompt);
*/

#endif /* __CRYPT_LIBRARY_H__ */
