
/****************************************************************************
 * $Header: /home/CVS/c/TinyCrack/Source/missing/strsep.c,v 1.6 2003/01/07 21:10:03 ralph Exp $
 *
 * $Log: strsep.c,v $
 * Revision 1.6  2003/01/07 21:10:03  ralph
 * Automatic checkin+commit, done by MakeDistribution.sh, using tag TinyCrack_2003-01-07
 *
 * Revision 1.5  2003/01/07 18:17:32  ralph
 * Changes for HPUX
 *
 * Revision 1.4  2003/01/03 15:43:08  ralph
 * y2k3 changes
 *
 * Revision 1.3  2001/12/06 19:50:19  ralph
 * CVS keywords added, PGCC ifdef added
 *
 *
 * Minor changes by and1000 on 15/1/97 to make it go under Nemesis
 * added index() - ralph, 11-Apr-2001
 * fixes for lcc/bcc32 - ralph, 3-Sept-2001
 *
 * (C)opyright by ROSE SWE, Dipl.Ing. Ralph Roth, ROSE_SWE@hotmail.com
 * All Rights Reserved!                        http://come.to/rose_swe
 *
 ****************************************************************************/


/* static char *_CMSID = "$CmsFile: strsep $ $Date: 2003/01/07 21:10:03 $"; */

/* Copyright (C) 1992, 1993 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/* for string functions */

#include <string.h>

char *strsep(char **pp, const char *delim)
{
    char *p, *q;

    static char szNullPointer[2] = "";

    if (!(p = *pp))
        return szNullPointer;

    if ((q = strpbrk (p, delim)))
    {
        *pp = q + 1;
        *q = '\0';
    }
    else
        *pp = szNullPointer;

    return p;
}

#if !defined(__DJGPP__) && !defined(linux)	/* already exists! */
char *index (char *s, int c)
{
  return strchr (s, c);
}
#endif

