/* $Id: gen_dict.c,v 1.2 2002/04/11 15:35:04 ralph Exp $ */

/*--------------------------------------------------------*/
/* Copyright (c) PSW-soft 1996-98 by P. Semjanov          */
/*                                                        */
/* Prototype for PCL 2.0 using                            */
/*                                                        */
/* Modified by ROSE SWE (RalphRoth@gmx.de) 05-Sept-2000   */
/* to create wordlists for password cracking tools	  */
/*                                                        */
/*--------------------------------------------------------*/

/* HINT:   gcc -s -O6 gen_dict.c pcl.a -O gen_dict.exe  */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "pcl.h"


int NO_USER_BRUTE = TRUE; // if no user's brute force function,
                          // else FALSE


/* main variables. Interface with user's module

char psw_chars[256];          // current password. '\0' is NOT GUARANTIED!
int psw_len;                  // current password lenghth

UPASS passwords;      // passwords tested. Must be incremented in user's module

*/

   FILE *hOut;

int main (argc, argv)
int argc;
char *argv[];
{
   printf("Password List Creator 1.00 - %s - Using PCL Libary 2.0\n", __DATE__);

   if (argc > 1) if (argv[1][0] == 'b') { benchmark(); exit(1); }

   passwords = 0;
   if ((hOut = fopen("your.dic","a")) == NULL) {
      puts("Cannot create dictionary 'your.dic', aborting!");
      perror("Fcreate");
      return -1;
   }

   parse_rules_file ("dict.def", 3, 8);	/* UNIX pwd style */
   printf("\nFinished your rules set, %ld password created!\n", (long) passwords);

   return fclose(hOut);

}

int test (void)
{

  passwords++;
  psw_chars[psw_len] = 0,			/* ???? */
  fprintf(hOut, "%s\n", psw_chars);

  return -1;

}

void init_brute_force()
{}

char *get_special (s, n)
char *s;
int16 n;
{
// if special charset defined

   if (n == 1) {
       s[2] = '\0';
     }

}

void brute_force (int len, char *charset) {
// must fill only if NO_USER_BRUTE == FALSE
}

void definition_done()
{
 test_definition();
}

