/* -----============================================================-----
 *
 *      Programm:       KeyBoard + Car Number Mutator
 *      Project:        Tiny Cracker - UNIX password cracker
 *      Compiler:       TC 2.00/SCO UNIX
 *      Standards:      ANSI/Hungarian Naming
 *	Version:	$Id: keybmut.c,v 1.3 2002/04/11 16:27:26 ralph Exp $
 *
 *  -----============================================================-----
 *      Remark:         This program runs on various platform, e.g.
 *                      DOS, UNIX or OS/2. So DON'T use Borland/MSC
 *                      specific functions. If you have done enhancements
 *                      then please comment them and add date and your
 *                      name below. Then send back the source code to:
 *                                  rose_swe@hotmail.com 
 *  -----============================================================-----
 *
 *      03.08.95        rar: Initial creation.
 *      12.12.95        rar: added car number mutator
 *
 *  -----============================================================-----
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define MAXKBF 31
#define getrandom(min, max) ((rand() % (int)(((max) +1) - (min))) + (min))

char szKeyB[MAXKBF][30] =
{
    "qwerty", "zuiop", "asdfg", "ghjkl", "yxcvb", "@bnm", "123", "345",
    "qaywsx", "edcrfv", "tgbz,", "hnujm", "ikolp", "plokm", "_ijnuhb", "hbzgv",
    "qawsed","qwopaskl","aypoisx", "123qwe", "qwertzuiop", "asdfghjkl",
    "yxcvbnm","poiuz", "trewq", "lkjhgf", "fdsa", "mnbv", "cxy", "678", "890"
};


void reverse_str(char *str1, char *str2)                        /* x642a */
{                /* src, dest */

    int length, i;

    length = strlen(str1);

    for(i = 0; i < length; i++)
	str2[i] = (&str1[length-i]) [-1];
    str2[length] = '\0';
}



void checkit(char *w)
{
    w[8] = 0;
    puts(w);
}

void checkitKB(char *szWord)
{
    int     iR1, iR2, iR3, nT;
    char    szT[60], szW[60];

    for (nT = 1; nT < 6; nT++)
    {
	iR1 = getrandom(0, MAXKBF-1);

	do {
	    iR2 = getrandom(0, strlen(szKeyB[iR1])-3);
	    iR3 = getrandom(iR2, strlen(szKeyB[iR1])-1);
	}
	while (iR3 - iR2 > 4);

	strcpy(szT, &szKeyB[iR1][iR2]);
	szT[iR3] = 0;

	sprintf(szW, "%s%s", szT, szWord);
	checkit(szW);
	reverse_str(szW, szT);
	checkit(szT);

	sprintf(szW, "%s%s", szWord, szT);
	checkit(szW);
	reverse_str(szW, szT);
	checkit(szT);
    }

}

void mutateKB(void)
{
    int     nT, nF;
    char    szTmp[60], szRev[60];

    for (nF=0; nF < MAXKBF; nF++)
    {
	for (nT = strlen(szKeyB[nF])-2; nT > 1 ; nT--)
	{
	    sprintf(szTmp, "%s", &szKeyB[nF][nT]);
	    checkitKB(szTmp);
	    reverse_str(szTmp, szRev);
	    checkitKB(szRev);
	    strcpy(szTmp, szKeyB[nF]);
	    szTmp[nT+1] = 0;
	    checkitKB(szTmp);
	    reverse_str(szTmp, szRev);
	    checkitKB(szRev);
	}
    }
}

void kfzmutate(char *szKFZ)
{
    int nT1, nT2, nT3;
    char  szT[40];

    checkit(szKFZ);
    for (nT1 = 'a'; nT1 <= 'z'; nT1++)
	for (nT2 = 'a'; nT2 <= 'z'; nT2++)
	{
	    sprintf(szT, "%s%c%c", szKFZ, nT1, nT2);
	    checkit(szT);
	    sprintf(szT, "%c%c%s", nT1, nT2, szKFZ);
	    checkit(szT);

	    for (nT3 = 0; nT3 < 1000; nT3++)
	    {
		sprintf(szT, "%s%c%c%i", szKFZ, nT1, nT2, nT3);
		checkit(szT);
		sprintf(szT, "%s%i%c%c", szKFZ, nT3, nT1, nT2);
		checkit(szT);
	    }
	}

} /* kfzmutate */

int main(void)
{
    srand( (unsigned)time( NULL ) );
    mutateKB();
    kfzmutate("bl"); /* if you want? */

    return 0;
}
