/*  $Header: /home/CVS/c/TinyCrack/Source/tools/strlen.c,v 1.5 2003/10/26 18:23:19 ralproth Exp $
 *  -----============================================================-----
 * strlen.c -   copyies strings from stdin to stdout if they are shorter
 *              (!longer) than "width"
 *
 *  -----============================================================-----
 *  Remark:     This program runs on various platform, e.g.
 *              DOS, UNIX or OS/2. So DON'T use Borland/MSC
 *              specific functions. If you have done enhancements
 *              then please comment them and add date and your
 *              name below. Then send back the source code to:
 *                       rose_swe@hotmail.com
 *  -----============================================================-----
 *
 * 12.06.95     1.00    intial creation         Ralph Roth
 * 20.01.96     1.01    added less operator
 * $Log: strlen.c,v $
 * Revision 1.5  2003/10/26 18:23:19  ralproth
 * New buggy CVS version?
 *
 * Revision 1.4  2003/02/23 18:41:34  ralph roth
 * Fixed bug with argc/argv, added ! operator
 *
 *
 *  -----============================================================-----
 *
 */

#include <stdio.h>
#include <string.h>

/* True = 1, False = 0 Width 7, Not operator = 0 */
char    szWork[2048];
int     nWidth, bLess = 0, nLen;

int main (int argc, char *argv[])
{
    if (argc > 1)
    {
        nWidth = - atoi(argv[argc-1]);
        bLess = (argv[argc-2][0] == '!');   /* else paramstr(0) */
    }
    else
        nWidth = 7;

    if (nWidth < 1)
    {
        printf("\nusage: %s [!] [-width]  (default width=7)\n\a", argv[0]);
        printf("Filters stdin to stdout, when line is shorter (! = longer) than width\n");
        printf("$Id: strlen.c,v 1.5 2003/10/26 18:23:19 ralproth Exp $\n");
        exit(1);
    };

    /* fprintf(stderr,"Width %i, Not operator = %i\n", nWidth, bLess); */

    while (!feof(stdin))
    {
        fgets(szWork, sizeof(szWork), stdin);
        nLen = strlen(szWork)-1;        /* \n */

        if ((nLen < nWidth) && !bLess)
            printf("%s", szWork);
        else
            if (bLess && (nLen >= nWidth))
                printf("%s", szWork);
    } /* while */

    return 0;
}
