/* $Id: pw_gen.c,v 1.5 2005/01/11 21:21:15 ralproth Exp $ */

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>


         /* 1st param is the desired password  */
         /* A random seed (2 chars) will be    */
         /* automatically chosen.              */
         /* For good passwords:                */
         /*     Use random chars, mixed apha-  */
         /*     numerics and MiXeD CaSe for    */
         /*     better protection.             */


int main(int argc, char **argv)
{

  char salt[3];
  char *EncryptedPasswd;
  int CheckRand;
  int Fixup;
  int SeedChar;


  printf("$Id: pw_gen.c,v 1.5 2005/01/11 21:21:15 ralproth Exp $\nUsage: pw  <password_to_encrypt>\n");

  /* if used with Fast-Crypt */
  // init_des();

  if (argc < 2)
	exit(-1);

/* Generate a random starting point for seed charcaters */

  srand(time(NULL));
  for ( SeedChar = 0; SeedChar <= 1; SeedChar++) {
      CheckRand = 46 + rand() % 76;   /* random number from 46 to 122  */
      Fixup = 7 + rand() % 13;          /* random number from 7 to 20    */
      salt[SeedChar] = toascii(((CheckRand >= 58 && CheckRand <= 64) ||
        (CheckRand >= 91 && CheckRand <= 96) ? CheckRand + Fixup : CheckRand));
  }
  salt[2] = 0;

  EncryptedPasswd = (char*) (crypt(argv[1], salt));
  printf("\nRequested pw= %s, Automatic Seed= %s, encrypted (crypt) pw= %s\n",
          argv[1], salt, EncryptedPasswd);

  return 0;
}
