/* getpwd.c, Ralph Roth, 08-Jan-97 */
/* getprpwd.c 10-jan-98 for trusted systems */

#include <stdio.h>
#include <pwd.h>
#include <grp.h>

/* dumps shadow pwd or yp */
/* $Id: unshadow.c,v 1.1 2003/03/05 18:55:47 ralph Exp $ */

/* get group entry, Ralph Roth, 08-Jan-98 */

void dump_group(void)
{
    struct group *g;
    char **n;

    while(g=getgrent())
    {
        printf("%s:%s:%i:", g->gr_name, g->gr_passwd,
               g->gr_gid);
        n = g->gr_mem;
        /* doesn t work yet
         
        		while (n)
        		{
        			printf("%s", *n);
        			n++;
        			if !(n) print(",");
        		};
        */
        printf("\n");
    };
    endgrent();
}


int main(void)
{
    struct passwd *p;

    puts("Groups:");
    dump_group();

    puts("Users:");
    while(p=getpwent())
        printf("%s:%s:%d:%d:%s:%s:%s\n", p->pw_name, p->pw_passwd,
               p->pw_uid, p->pw_gid, p->pw_gecos, p->pw_dir, p->pw_shell);

    endpwent();
    return 0;

}
